import numpy as np
import algorithm as alg


class detection:
	snrA=-1
	snrB=-1
	snrC=-1
	snrD=-1
	tag_id=-1
	depth=-1
	fullPos=-1
	posX=-1
	posY=-1
	lowestSNR=-1
	time=-1
	Ta=-1
	Tb=-1
	Tc=-1
	Td=-1
	def __init__(self):
		pass


class fish:
	
	def __init__(self, tag_id, hydrophone_positions,recvNodes):
		self.recvNodes=recvNodes

		self.detections = []

		self.tag_id=tag_id
		self.positions = []
		
		self.r_t = []
		self.snrvals=[]			
		self.depth_data = []
		self.h_p = hydrophone_positions

		self.detection_times = []
	def setPositions(self):
		for i in range(0,len(self.r_t)):
					
			pos = alg.redundantPosition(self.h_p[0],self.h_p[1],self.h_p[2], self.h_p[3], self.r_t[i][0],self.r_t[i][1],self.r_t[i][2], self.r_t[i][3],1482.0, 0.0)
			if(pos):
				det=detection()
				det.time=int(self.r_t[i][0])
				det.depth=self.depth_data[i]
				det.posX=pos[0]
				det.posY=pos[1]
				det.fullPos=[pos[0],pos[1]]
				det.tag_id=self.tag_id
				det.snrA=self.snrvals[i][0]
				det.snrB=self.snrvals[i][1]
				det.snrC=self.snrvals[i][2]				
				det.snrD=self.snrvals[i][3]
				det.Ta=self.r_t[i][0]
				det.Tb=self.r_t[i][1]
				det.Tc=self.r_t[i][2]
				det.Td=self.r_t[i][3]

				self.detections.append(det)
				self.positions.append(pos)
				
	def addReceptionTimes(self, reception_times):
		self.r_t.append(reception_times)
	def addDepthData(self,depth):
		self.depth_data.append(depth)
	def addSNRData(self,snr):
		self.snrvals.append(snr)

