clear all;
loadpos

c_w=1482;
A =[0, 0];
B =[43.0368, 0];
C =[21.3598, 39.2669];
D =[18.4263, 14.6232];


%mid position
pos1=[17.9709, 13.8616];

%mid little triangle
pos2=[16.9899, 8.0518];

pos4=[16.7193, -12.9528];



% % % %%%pos1
t_0=1464347199;
t_1=1464348292;
pos1a=[pos1;A];
pos1b=[pos1;B];
pos1c=[pos1;C];
pos1d=[pos1;D];
A1=pdist(pos1a,'euclidean');
B1=pdist(pos1b,'euclidean');
C1=pdist(pos1c,'euclidean');
D1=pdist(pos1d,'euclidean');
tab_real=1000*(A1/c_w-B1/c_w);
tac_real=1000*(A1/c_w-C1/c_w);
tad_real=1000*(A1/c_w-D1/c_w);

% %%%pos2
% t_0=1464348291;
% t_1=1464349364;
% pos1a=[pos2;A];
% pos1b=[pos2;B];
% pos1c=[pos2;C];
% pos1d=[pos2;D];
% A1=pdist(pos1a,'euclidean');
% B1=pdist(pos1b,'euclidean');
% C1=pdist(pos1c,'euclidean');
% D1=pdist(pos1d,'euclidean');
% tab_real=1000*(A1/c_w-B1/c_w);
% tac_real=1000*(A1/c_w-C1/c_w);
% tad_real=1000*(A1/c_w-D1/c_w);
% % 
% 
% 
% %%%pos4
% t_0=1464345839;
% t_1=1464346810;
% pos1a=[pos4;A];
% pos1b=[pos4;B];
% pos1c=[pos4;C];
% pos1d=[pos4;D];
% A1=pdist(pos1a,'euclidean');
% B1=pdist(pos1b,'euclidean');
% C1=pdist(pos1c,'euclidean');
% D1=pdist(pos1d,'euclidean');
% tab_real=1000*(A1/c_w-B1/c_w);
% tac_real=1000*(A1/c_w-C1/c_w);
% tad_real=1000*(A1/c_w-D1/c_w);

c=1;
i=1;
while 1
    if(timestamp(c)>t_0 & timestamp(c)<t_1)
       t_n(i)=timestamp(c);
       x_n(i)=x(c);
       y_n(i)=y(c);
       z_n(i)=z(c);
       Tab_n(i)=Tab(c)*1000;
       Tac_n(i)=Tac(c)*1000;
       Tad_n(i)=Tad(c)*1000;
       snrA_n(i)=snrA(c);
       snrB_n(i)=snrB(c);
       snrC_n(i)=snrC(c);
       snrD_n(i)=snrD(c);
       i=i+1;
        
    end
    if(timestamp(c)>t_1)
        break;
    end
    c=c+1;
end

edge=-35.5:1:51.5;

Tab_n=round(Tab_n);
Tac_n=round(Tac_n);
Tad_n=round(Tad_n);

Tab_mode=mode(Tab_n);
Tac_mode=mode(Tac_n);
Tad_mode=mode(Tad_n);


tabc_1=0;
tabc_c=0;
u=1;
for i=1:length(Tab_n)
   if((((Tab_n(i)==Tab_mode)|(Tab_n(i)==Tab_mode-1)|(Tab_n(i)==Tab_mode+1)) & ((Tac_n(i)==Tac_mode)|(Tac_n(i)==Tac_mode+1)|(Tac_n(i)==Tac_mode-1))))
      tabc_1=tabc_1+1;
      snrsa(u)=snrA_n(i);
      snrsb(u)=snrB_n(i);
      snrsc(u)=snrC_n(i);
      u=u+1;
   end
   if((Tab_n(i)==Tab_mode)&(Tac_n(i)==Tac_mode))
       tabc_c=tabc_c+1;
   end
end

disp('Signals in +-1ms region%')
tabc_1
tabc_1/length(Tab_n)

disp('Signals in +-0ms region%')
tabc_c
tabc_c/length(Tab_n)


mean(snrsa)-mean(snrA_n);
mean(snrsb)-mean(snrB_n);
mean(snrsc)-mean(snrC_n);


%%%setup vertical lines
y_vert=0:1;
tab_target=tab_real*ones(1,length(y_vert));
tac_target=tac_real*ones(1,length(y_vert));
tad_target=tad_real*ones(1,length(y_vert));

figure(1); clf(1);
hold on;
[x1,y1]=hPositioningTDOACurve(A,B,c_w*mode(round(Tab_n)+0.000001)/1000);
plot(x1,y1,'blue');
% [x1,y1]=hPositioningTDOACurve(A,B,c_w*-0.004);
% plot(x1,y1,'blue');

[x2,y2]=hPositioningTDOACurve(A,C,c_w*mode(round(Tac_n)+0.000001)/1000);
plot(x2,y2,'red');
x2=(B(1)/2)*(ones(length(y2)));
% [x2,y2]=hPositioningTDOACurve(A,C,c_w*-0.020);
% plot(x2,y2,'red');

[x3,y3]=hPositioningTDOACurve(A,D,c_w*mode(round(Tad_n)+0.000001)/1000);
plot(x3,y3,'green');
% [x3,y3]=hPositioningTDOACurve(A,D,c_w*-0.002);
% plot(x3,y3,'green');
scatter(x_n,y_n);


legend('T_{ab} LOP','T_{ac} LOP','T_{ad} LOP');


ylim([-35,40]); 
xlim([-10,50]);


%%%%CIRCLE%%%%
r=25.4777;
x_offset=44.133/2;
y_offset=12.74;
th = 0:pi/100:2*pi;
xunit = r*cos(th)+x_offset;
yunit = r*sin(th)+y_offset;
plot(xunit, yunit, '--k', 'linewidth', 3);

scatter(A(1),A(2),'filled','red');
scatter(B(1),B(2),'filled','red');
scatter(C(1),C(2),'filled','red');
scatter(D(1),D(2),'filled','red');

dx=1; dy=1;
scatter(pos1(1),pos1(2),100,100,'black','+','lineWidth',2);
%text(pos1(1)+dx,pos1(2)+dy,'pos2');

scatter(pos2(1),pos2(2),100,100,'black','+','lineWidth',2);
%text(pos2(1)+dx,pos2(2)+dy,'pos3');

% scatter(pos3(1),pos3(2),100,100,'black','+','lineWidth',2);
% %text(pos3(1)+dx,pos3(2)+dy,'pos4');
% 
% scatter(posmid(1),posmid(2),100,100,'black','+','lineWidth',2);
% %text(posmid(1)+dx,posmid(2)+dy,'pos1');

scatter(pos4(1),pos4(2),100,100,'black','+','lineWidth',2);
%text(pos4(1)+dx,pos4(2)+2*dy,'pos5');

scatter(D(1),D(2),'red','filled');
%text(D(1)+dx,D(2)+dy,'D');

scatter(A(1),A(2),'red','filled');
text(A(1)+dx,A(2)+dy,'A');

scatter(C(1),C(2),'red','filled');
text(C(1)+dx,C(2)+dy,'C');

scatter(B(1),B(2),'red','filled');
text(B(1)+dx,B(2)+dy,'B');

hold off;

figure(2); clf(2);
hold on;
h = histogram(Tab_n,edge);
title(' Probability mass of T_{ab}');
xlabel('Time difference, T_{ab} [ms]');
ylabel('Probability');
h.Normalization='probability';
plot(tab_target,y_vert,'red');
hold off;

% 
figure(3); clf(3);
hold on;
h=histogram(Tac_n,edge);
title(' Probability mass of T_{ac}');
xlabel('Time difference, T_{ac} [ms]');
ylabel('Probability');
h.Normalization='probability';
plot(tac_target,y_vert,'red');
hold off;


% 
figure(4); clf(4);
hold on;
h=histogram(Tad_n,edge);
title(' Probability mass of T_{ad}');
xlabel('Time difference, T_{ad} [ms]');
ylabel('Probability');
h.Normalization='probability';
plot(tad_target,y_vert,'red');
hold off;


figure(5); clf(5);
hold on;
h=histogram(snrA_n,edge);
h.Normalization='probability';
h=histogram(snrB_n,edge);
legend('SNR at A','SNR at B')
h.Normalization='probability';


title(' Probability mass of SNR values');
xlabel('SNR value [dB]');
ylabel('Probability');
hold off;


figure(6); clf(6);
hold on;
h=histogram(snrC_n,edge);
h.Normalization='probability';
h=histogram(snrD_n,edge);
legend('SNR at C','SNR at D')
h.Normalization='probability';


title(' Probability mass of SNR values');
xlabel('SNR value [dB]');
ylabel('Probability');
hold off;







edgeab=(0.5+min(Tab_n)):1:(0.5+max(Tab_n));
edgeac=(0.5+min(Tac_n)):1:(0.5+max(Tac_n));


Tabc=[transpose(Tab_n), transpose(Tac_n)];

edgy={(edgeab);(edgeac)};
figure(7); clf(7);
hold on;
hist3(Tabc,'Edges',edgy);
xlabel('T_{ab}'); ylabel('T_{ac}')
title('3d representation of signal time differences')
set(get(gca,'child'),'FaceColor','interp','CDataMode','auto');
%h.Normalization='probability';
hold off;