import logParser as lp

import numpy as np
import matplotlib.pyplot as plt
from matplotlib.widgets import Slider, Button, RadioButtons
import time

fnr=4







x=[]
y=[]
z=[]
t=[]
lowsnr=[]
Ta=[]
Tb=[]
Tc=[]
Td=[]
snrA=[]
snrB=[]
snrC=[]
snrD=[]



fishy= lp.fishes[fnr].detections

detections = {}

fish_list = (lp.tag_list)

#Sets up normal distributed uncertainty.
mu, sigma = 0, 0.15
noise1 = np.random.normal(mu,sigma,5000)
noise2 = np.random.normal(mu,sigma,5000)
noise3 = np.random.normal(mu,sigma,5000)

for fnr in fish_list:
	filename="posdata/Tag_id_"+str(fnr)+".txt"
	f=open(filename,"w+")
	f.write("%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%Information%%%%%%%%%%%%%%%%%%%%%%%%%%%\n")
	f.write("lowestSNR is the lowest SNR value for the signal across all receivers\n")
	f.write("Tab is reception time difference between receivers A and B\n")
	
	positions="Receiver positions:(x,y)\n"+"A at"+str(lp.fishes[fnr].h_p[0])+"\n"
	positions=positions+"B at"+str(lp.fishes[fnr].h_p[1])+"\n"
	positions=positions+"C at"+str(lp.fishes[fnr].h_p[2])+"\n"
	positions=positions+"D at"+str(lp.fishes[fnr].h_p[3])+"\n"
	f.write(positions)


	f.write("%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%\n")
	f.write("ID,timestamp,x,y,z,Tab,Tac,Tad,snrA,snrB,snrC,snrD\n")
	for i in range(0,len(lp.fishes[fnr].detections)):
		x.append(lp.fishes[fnr].detections[i].posX)
		y.append(lp.fishes[fnr].detections[i].posY)
		z.append(lp.fishes[fnr].detections[i].depth)
		t.append(lp.fishes[fnr].detections[i].time)
		Ta.append(lp.fishes[fnr].detections[i].Ta)		
		Tb.append(lp.fishes[fnr].detections[i].Tb)
		Tc.append(lp.fishes[fnr].detections[i].Tc)
		Td.append(lp.fishes[fnr].detections[i].Td)
		snrA.append(lp.fishes[fnr].detections[i].snrA)
		snrB.append(lp.fishes[fnr].detections[i].snrB)
		snrC.append(lp.fishes[fnr].detections[i].snrC)
		snrD.append(lp.fishes[fnr].detections[i].snrD)		
		print Ta[i]-Tb[i]
		datastr = str(fnr)+","+str(t[i])+","+str(x[i])+","+str(y[i])+","+str(z[i])+","+str(Ta[i]-Tb[i])+","+str(Ta[i]-Tc[i])+","+str(Ta[i]-Td[i])+","+str(snrA[i])+","+str(snrB[i])+","+str(snrC[i])+","+str(snrD[i])+"\n"
		f.write(datastr)
		print i,datastr


	f.close()
