clear all;
c=1500;
sigma_r=c*0.001;
sigma_r=1;
z=0;
p1=[0, 0];
p2=[43.0368, 0];
p3=[21.3598, 39.2669];
p4=[21.3598, 39.2669*2-7];
% 
%  

%%%Triangle%%%
p1=[0, 0];
p2=[44.133, 0];
p3=[22.066, 38.22];
p4=[22.066, 12.74];


p=[p1,
    p2,
    p4];


step=0.3;
xmin=-7;
xmax=51;
ymin=-16;
ymax=43;



counter1=1;
for u=ymin:step:ymax;
    
    y=u;
    counter2=1;
    for v=xmin:step:xmax
        x=v;
        for i=1:length(p)
            xi=p(i,1);
            yi=p(i,2);
            zi=1;
            Ri=sqrt((xi-x)^2+(yi-y)^2);
            [(xi-x)/Ri (yi-i)/Ri];
            M(i,:) = [(xi-x)/Ri (yi-y)/Ri sigma_r];
            sqrt(M(i,1)^2+M(i,2)^2);
        end
        kd=sqrt(trace(inv(transpose(M)*M)));
        if(kd<30) %Saturation to prevent contourf(..) from crashing
            dopx(counter2)=kd;
        else
            dopx(counter2)=30;
        end
        counter2=counter2+1;
    end
    doptot(counter1,:)=dopx;
    counter1=counter1+1;
end

%doptot=doptot1.*doptot;
x=[xmin:step:xmax];
y=[ymin:step:ymax];
figure(1); clf(1);
hold on;


[C, h]=contourf(x,y,doptot);
h.LevelStep=0.1; %Adjust step size for color axis
colorbar;
caxis([1,4]); %cap loss  values at 20 for more readable scale
colormap(jet); %Color ranges from blue to red


%%%%CIRCLE%%%%
r=25.4777;
x_offset=44.133/2;
y_offset=12.74;
th = 0:pi/100:2*pi;
xunit = r*cos(th)+x_offset;
yunit = r*sin(th)+y_offset;
plot(xunit, yunit, '--g', 'linewidth', 3);

scatter(p1(1),p1(2),'filled', 'red');
scatter(p2(1),p2(2),'filled', 'red');
scatter(p3(1),p3(2),'filled', 'red');
scatter(p4(1),p4(2),'filled', 'red');