clear all;
ssm22.lat=64.600199854;
ssm22.lon=10.853439548;

ssm25.lat=64.599859306;
ssm25.lon=10.852940803;

ssm42.lat=64.599862003;
ssm42.lon=10.853874374;

ssm45.lat=64.599943206; %newD
ssm45.lon=10.853420908;

pos2.lat=64.599942936; %pos2, MID
pos2.lon=10.853439430;

pos1.lat=64.599960443; %pos3 , mid lille tri
pos1.lon=10.853555541;

pos45.lat=64.599943206;
pos45.lon=10.853420908;

pos3.lat=64.599893335;
pos3.lon=10.853738957;

pos4.lat=64.600049458;
pos4.lon=10.853942223;

llo=[ssm42.lat ssm42.lon];
lla=[ssm42.lat ssm42.lon 0];

sn42=lla2flat(lla,llo,-28.930-180,0);

lla=[ssm22.lat ssm22.lon 0];
sn22=lla2flat(lla,llo,-28.930,0);

lla=[ssm25.lat ssm25.lon 0];
sn25=lla2flat(lla,llo,-28.930,0);

lla=[ssm45.lat ssm45.lon 0];
sn45=lla2flat(lla,llo,-28.930,0);

lla=[pos2.lat pos2.lon 0];
pos2=lla2flat(lla,llo,-28.930,0);

lla=[pos45.lat pos45.lon 0];
pos45=lla2flat(lla,llo,-28.930,0);

lla=[pos1.lat pos1.lon 0];
pos1=lla2flat(lla,llo,-28.930,0);

lla=[pos3.lat pos3.lon 0];
pos3=lla2flat(lla,llo,-28.930,0);

lla=[pos4.lat pos4.lon 0];
pos4=lla2flat(lla,llo,-28.930,0);


figure(1);clf(1);
hold on;

%%%%CIRCLE%%%%
r=25.4777;
x_offset=44.133/2;
y_offset=12.74;
th = 0:pi/100:2*pi;
xunit = r*cos(th)+x_offset;
yunit = r*sin(th)+y_offset;
plot(xunit, yunit, '--k', 'linewidth', 3);
ylim([-20,45]);

dx=1; dy=1;
scatter(sn45(1),-sn45(2),'red','filled');
text(sn45(1)+dx,-sn45(2)+dy,'TBR4');

scatter(sn42(1),-sn42(2),'red','filled');
text(sn42(1)+dx,-sn42(2)+dy,'TBR1');

scatter(sn25(1),-sn25(2),'red','filled');
text(sn25(1)+dx,-sn25(2)+dy,'TBR3');

scatter(sn22(1),-sn22(2),'red','filled');
text(sn22(1)+dx,-sn22(2)+dy,'TBR2');


scatter(pos2(1),-pos2(2),'black','filled');
% scatter(pos45(1),-pos45(2),'cyan','filled');
scatter(pos1(1),-pos1(2),'black','filled');
% scatter(pos3(1),-pos3(2),'green','filled');
% scatter(pos4(1),-pos4(2),'blue','filled');

sn45
pos2
pos1

hold off;