clear all;
loadpos

c_w=1482;
A =[0, 0];
B =[43.0368, 0];
C =[21.3598, 39.2669];
D =[18.5347, 12.9517];

posmid=[23.7235, 11.8945]
pos1=[16.8973, 8.1844];
pos2=[21.4669, 0.2398];
pos3=[6.1937, 3.9849];
pos4=[16.7193, -12.9528];

% A =[0, 0];
% B =[44.133, 0];
% C =[22.066, 38.22];
D =[22.066, 12.74];



% % %%%pos1
t_0=1464335140;
t_1=1464337474;
pos1a=[pos1;A];
pos1b=[pos1;B];
pos1c=[pos1;C];
pos1d=[pos1;D];
A1=pdist(pos1a,'euclidean');
B1=pdist(pos1b,'euclidean');
C1=pdist(pos1c,'euclidean');
D1=pdist(pos1d,'euclidean');
tab_real=1000*(A1/c_w-B1/c_w);
tac_real=1000*(A1/c_w-C1/c_w);
tad_real=1000*(A1/c_w-D1/c_w);


%%%pos2
t_0=1464337582;
t_1=1464339561;
pos1a=[pos2;A];
pos1b=[pos2;B];
pos1c=[pos2;C];
pos1d=[pos2;D];
A1=pdist(pos1a,'euclidean');
B1=pdist(pos1b,'euclidean');
C1=pdist(pos1c,'euclidean');
D1=pdist(pos1d,'euclidean');
tab_real=1000*(A1/c_w-B1/c_w);
tac_real=1000*(A1/c_w-C1/c_w);
tad_real=1000*(A1/c_w-D1/c_w);

%%%pos3
t_0=1464339793;
t_1=1464341192;
pos1a=[pos3;A];
pos1b=[pos3;B];
pos1c=[pos3;C];
pos1d=[pos3;D];
A1=pdist(pos1a,'euclidean');
B1=pdist(pos1b,'euclidean');
C1=pdist(pos1c,'euclidean');
D1=pdist(pos1d,'euclidean');
tab_real=1000*(A1/c_w-B1/c_w);
tac_real=1000*(A1/c_w-C1/c_w);
tad_real=1000*(A1/c_w-D1/c_w);


c=1;
i=1;
while 1
    if(timestamp(c)>t_0 & timestamp(c)<t_1)
       t_n(i)=timestamp(c);
       x_n(i)=x(c);
       y_n(i)=y(c);
       z_n(i)=z(c);
       Tab_n(i)=Tab(c)*1000;
       Tac_n(i)=Tac(c)*1000;
       Tad_n(i)=Tad(c)*1000;
       snrA_n(i)=snrA(c);
       snrB_n(i)=snrB(c);
       snrC_n(i)=snrC(c);
       snrD_n(i)=snrD(c);
       if(Tac_n(i)<-23)
           disp('yo')
           disp(i)
           disp(c)
       end
       i=i+1;
        
    end
    if(timestamp(c)>t_1)
        break;
    end
    c=c+1;
end

edge=-35.5:1:50.5;

Tab_n=round(Tab_n);
Tac_n=round(Tac_n);
Tad_n=round(Tad_n);

tabc=0
u=1;
for i=1:length(Tab_n)
   if(not(((Tab_n(i)==2)|(Tab_n(i)==2)|(Tab_n(i)==2))))% & ((Tac_n(i)==-1)|(Tac_n(i)==0)|(Tac_n(i)==1))))
      tabc=tabc+1;
      snrsa(u)=snrA_n(i);
      snrsb(u)=snrB_n(i);
      snrsc(u)=snrC_n(i);
      u=u+1;
   end
    
end

mean(snrsa)-mean(snrA_n)
mean(snrsb)-mean(snrB_n)
mean(snrsc)-mean(snrC_n)

tabc/length(Tab_n)

%%%setup vertical lines
y_vert=0:1;
tab_target=tab_real*ones(1,length(y_vert))
tac_target=tac_real*ones(1,length(y_vert))
tad_target=tad_real*ones(1,length(y_vert))

figure(1); clf(1);
hold on;
[x1,y1]=hPositioningTDOACurve(A,B,c_w*mode(round(Tab_n)+0.000001)/1000);
plot(x1,y1,'blue');
% [x1,y1]=hPositioningTDOACurve(A,B,c_w*-0.004);
% plot(x1,y1,'blue');

[x2,y2]=hPositioningTDOACurve(A,C,c_w*mode(round(Tac_n)+0.000001)/1000);
plot(x2,y2,'red');
x2=(B(1)/2)*(ones(length(y2)));
% [x2,y2]=hPositioningTDOACurve(A,C,c_w*-0.020);
% plot(x2,y2,'red');

[x3,y3]=hPositioningTDOACurve(A,D,c_w*mode(round(Tad_n)+0.000001)/1000);
plot(x3,y3,'green');
% [x3,y3]=hPositioningTDOACurve(A,D,c_w*-0.002);
% plot(x3,y3,'green');
scatter(x_n,y_n);


legend('T_{ab} LOP','T_{ac} LOP','T_{ad} LOP');


ylim([-35,40]); 
xlim([-10,50]);


%%%%CIRCLE%%%%
r=25.4777;
x_offset=44.133/2;
y_offset=12.74;
th = 0:pi/100:2*pi;
xunit = r*cos(th)+x_offset;
yunit = r*sin(th)+y_offset;
plot(xunit, yunit, '--k', 'linewidth', 3);

scatter(A(1),A(2),'filled','red');
scatter(B(1),B(2),'filled','red');
scatter(C(1),C(2),'filled','red');
scatter(D(1),D(2),'filled','red');

dx=1; dy=1;
scatter(pos1(1),pos1(2),100,100,'black','+','lineWidth',2);
%text(pos1(1)+dx,pos1(2)+dy,'pos2');

scatter(pos2(1),pos2(2),100,100,'black','+','lineWidth',2);
%text(pos2(1)+dx,pos2(2)+dy,'pos3');

scatter(pos3(1),pos3(2),100,100,'black','+','lineWidth',2);
%text(pos3(1)+dx,pos3(2)+dy,'pos4');

scatter(posmid(1),posmid(2),100,100,'black','+','lineWidth',2);
%text(posmid(1)+dx,posmid(2)+dy,'pos1');

scatter(pos4(1),pos4(2),100,100,'black','+','lineWidth',2);
%text(pos4(1)+dx,pos4(2)+2*dy,'pos5');

scatter(D(1),D(2),'red','filled');
%text(D(1)+dx,D(2)+dy,'D');

scatter(A(1),A(2),'red','filled');
text(A(1)+dx,A(2)+dy,'A');

scatter(C(1),C(2),'red','filled');
text(C(1)+dx,C(2)+dy,'C');

scatter(B(1),B(2),'red','filled');
text(B(1)+dx,B(2)+dy,'B');

hold off;

figure(2); clf(2);
hold on;
h = histogram(Tab_n,edge);
title(' Probability mass of T_{ab}');
xlabel('Time difference, T_{ab} [ms]');
ylabel('Probability');
h.Normalization='probability';
plot(tab_target,y_vert,'red');
hold off;

% 
figure(3); clf(3);
hold on;
h=histogram(Tac_n,edge);
title(' Probability mass of T_{ac}');
xlabel('Time difference, T_{ac} [ms]');
ylabel('Probability');
h.Normalization='probability';
plot(tac_target,y_vert,'red');
hold off;


% 
figure(4); clf(4);
hold on;
h=histogram(Tad_n,edge);
title(' Probability mass of T_{ad}');
xlabel('Time difference, T_{ad} [ms]');
ylabel('Probability');
h.Normalization='probability';
plot(tad_target,y_vert,'red');
hold off;


figure(5); clf(5);
hold on;
h=histogram(snrA_n,edge);
h.Normalization='probability';
h=histogram(snrB_n,edge);
legend('SNR at A','SNR at B')
h.Normalization='probability';


title(' Probability mass of SNR values');
xlabel('SNR value [dB]');
ylabel('Probability');
hold off;


figure(6); clf(6);
hold on;
h=histogram(snrC_n,edge);
h.Normalization='probability';
h=histogram(snrD_n,edge);
legend('SNR at C','SNR at D')
h.Normalization='probability';


title(' Probability mass of SNR values');
xlabel('SNR value [dB]');
ylabel('Probability');
hold off;